local origMUp = ZO_ChatterOption_MouseUp
local origMEntr = ZO_ChatterOption_MouseEnter
local origHndl = INTERACTION.HandleChatterOptionClicked

local isMouse = false
local highlightedOpt = nil

local function DlgKybd_IsImpOpt(opt)
	if (INTERACTION.importantOptions ~= nil) and (#INTERACTION.importantOptions > 1) then
		for _, v in pairs(INTERACTION.importantOptions) do
			if v == opt then
				return true
			end
		end
	end
	return false
end

local function DlgKybd_SetOptsHghLgt(opt)
	if INTERACTION.importantOptions == nil then return end
	if opt then
		for _, v in pairs(INTERACTION.importantOptions) do
			if v == opt then
				v:SetColor(0.77254903316498, 0.76078432798386, 0.61960786581039, 1.0)
				ZO_InteractWindowPlayerAreaHighlight:SetAnchorFill(opt)
				ZO_InteractWindowPlayerAreaHighlight:SetHidden(false)
			else
				v:SetColor(1.0, 0.0, 0.0, 1.0)
			end
		end
	else
		for _, v in pairs(INTERACTION.importantOptions) do
			v:SetColor(0.77254903316498, 0.76078432798386, 0.61960786581039, 1.0)
			ZO_InteractWindowPlayerAreaHighlight:SetHidden(true)
			ZO_InteractWindowPlayerAreaHighlight:ClearAnchors()
		end
	end
end

local function DlgKybd_Init(eventCode, addOnName)
	if addOnName == "DialogImportanceKbd" then
		ZO_ChatterOption_MouseEnter = function(...)
			if highlightedOpt then
				highlightedOpt = nil
				DlgKybd_SetOptsHghLgt(highlightedOpt)
			end
			origMEntr(unpack({...}))
		end
		ZO_ChatterOption_MouseUp = function(...)
			isMouse = true
			origMUp(unpack({...}))
		end
		
		INTERACTION.HandleChatterOptionClicked = function(meta, option, mouse)
			if not DlgKybd_IsImpOpt(option) or option == highlightedOpt or isMouse then
				highlightedOpt = nil
				isMouse = false
				DlgKybd_SetOptsHghLgt(highlightedOpt)
				origHndl(meta, option)
			else
				highlightedOpt = option
				DlgKybd_SetOptsHghLgt(highlightedOpt)
			end
		end
	end
end
EVENT_MANAGER:RegisterForEvent("DialogImportanceKbd", EVENT_ADD_ON_LOADED, DlgKybd_Init)